﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ws.theia.minecraft.bukkit.permissionsEx.editor {
	public partial class MainWindowForm:Form {
		private MainWindow mwinObj;
		public MainWindowForm(MainWindow mwinObj) {
			InitializeComponent();
			this.userEditTab.mode=1;
			this.groupEditTab.mode=0;
			this.mwinObj=mwinObj;
		}

		private void MainWindowForm_FormClosed(object sender,FormClosedEventArgs e) {
			this.mwinObj.Close();
		}

		private void exitMenuItem_Click(object sender,EventArgs e) {
			this.Close();
		}

		private mysqlConnector connector;

		private void connectMenuItem_Click(object sender,EventArgs e) {

			var accoutData=new loginWindow();

			accoutData.ShowDialog();

			this.connector=new mysqlConnector(accoutData.Server,accoutData.Database,accoutData.UserID,accoutData.Password);
			this.userEditTab.connector=connector;
			this.userEditTab.loadEntityList();
			this.groupEditTab.connector=connector;
			this.groupEditTab.loadEntityList();

		}

		private void closeMenuItem_Click(object sender,EventArgs e) {
			this.closeConnection();
		}

		private void closeConnection() {
			if(this.connector!=null) {
				if(this.userEditTab.unSaveTable+this.groupEditTab.unSaveTable>0) {
					if(System.Windows.Forms.MessageBox.Show(this,"未保存のデータが存在します。\r\n保存しますか。","データの保存",MessageBoxButtons.YesNo,MessageBoxIcon.Question,MessageBoxDefaultButton.Button1)==System.Windows.Forms.DialogResult.OK) {
						this.userEditTab.commit();
						this.groupEditTab.commit();
					} else {
						this.userEditTab.rollback();
						this.groupEditTab.rollback();
					}
				}
				this.userEditTab.closeConnection();
				this.groupEditTab.closeConnection();
				this.connector.close();
				this.connector=null;
			}
		}

		private void MainWindowForm_FormClosing(object sender,FormClosingEventArgs e) {
			this.closeConnection();
		}
	}
}
